/* radio.c 
 * the main magody
 * based on: gideon le grange, 1994
 * there is no change history here, since the whole file was 
 * rewrite for control /dev/radio  
 * Petr Blaha <engeeer@h-tech.cz> 1999 
 */

#define NameLen     10
#define MAXStations 10 
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "radio.h"
#include "card.h"

#define NONE   0
#define FREQ   2
#define VOLUME 1

#define MAXBUF 256
station stations[NumStations];

char defaultstation[NameLen];
double DefaultFreq=91.9;
int stat=0;   /* num of stations */
FILE* yyin;

void yylex()
{
char buf[MAXBUF];
char s1[MAXBUF] , s2[MAXBUF] , s3[MAXBUF]; 
int  i;

for(i = 0 , stat = 0; !feof( yyin) ; i ++)
{
fgets( buf , MAXBUF -1 , yyin );

   sscanf( buf ,  "%s %s %s" , s1 , s2 , s3 );

   if( strcmp(s1,"station")==0)
       {

        if( stat < MAXStations )
          {
		strncpy(  stations[stat].name , s2 , NameLen);
                /* delete "station" in s1 */
		strcpy(  s1 , "\0" );
	        stations[stat].freq = atof ( s3 );
	        stat++;
          }

       }
   if( strcmp(s1,"default")==0)
       {
        strncpy(  defaultstation , s2 , NameLen);
       }

}

/* get default freq */
for( i = 0 ; i < stat ; i ++ )
  if( strcmp(defaultstation ,stations[i].name)==0) 
     {
        DefaultFreq=stations[i].freq;
      }
}

int main(int argc, char **argv)
{
int errdev;
int volume = 8;
char *myname;
char *configfile = "/etc/radio.conf";
double MinFreq=87.000;
double MaxFreq=109.000;
int i;
int doit=NONE;


   myname=argv[0];
   
   yyin=fopen( configfile,"r");

   if (yyin==NULL)
     {
	printf("%s: Error opening configuration file %s\n",
                     myname , configfile);
     }
  else  yylex(); 
 
  /* ok, now ve hav ze station info */

 
  
   if (argc!=2) 
     {
        /* print Stations info */
        printf("configuration file: %s\n" , configfile );
	for( i = 0 ; i < stat ; i ++ )
	printf("%3.2f MHz %s\n" , stations[i].freq , stations[i].name );
	printf("Default: %s\n" , defaultstation );
	printf("\n");
	printf("radio v%s for /dev/radio\n",version);
        printf("author: Petr Blaha <engeneer@h-tech.cz>\n");
	printf("usage: radio on | off | <volume: [0-16]> | <channel> | <freq: [87.0-109.0]>\n");
        CardOff();
	exit(-1);
     }
   else
     {


	/* Init /dev/radio */
	 errdev = CardInit();
 
  if (errdev == 40) 
     {
	printf("%s: Can not open /dev/radio\n" , myname );
        exit(-1);
     }

	if (strcmp(argv[1],"on")==0) 
	  {
	      Tune(DefaultFreq);
	      setVolume(volume);
	      CardClose();
	      exit(0);
	  }
	if (strcmp(argv[1],"off")==0) 
	  {
	      Tune(DefaultFreq);
	      CardOff();
	      CardClose();
	      exit(0);
	  }



	/* ok, so it is channel name */
        for (i=0; i<stat; ++i)
	  {
	     if (strcmp(argv[1],stations[i].name)==0)
	       {
		  Tune(stations[i].freq);
                  setVolume(volume);
                  CardClose();
		  exit(0);
	       }
	  }

/* scan argv[1] if it's float-> frequency or 0-16 volume */

          /* set volume */
	  if( strlen( argv[1] ) > 0 )  doit = VOLUME ;

          /* set frequency */
          for( i = 0 ;i < strlen( argv[1] ) ; i ++ )
               if( argv[1][i] == '.' ) doit = FREQ ;
	  
        if( doit == VOLUME )
           {
              sscanf(argv[1],"%d",&volume);                 
              setVolume(volume);
              CardClose();
           }


        if( doit == FREQ )
        {
	  DefaultFreq=0.0;
	  sscanf(argv[1],"%lf",&DefaultFreq);
	  if ((DefaultFreq<MinFreq) || (DefaultFreq>MaxFreq))
	   {
	     printf("%s : Invalid frequency or channel %s\n",myname,argv[1]);  
             CardClose();
	     exit(-1);
	   }
	  else
	   {
	      Tune(DefaultFreq);
	     /* setVolume(volume); */
	      CardClose();
	      exit(0);
	   }
        }



     }

/* end of main */
}
